unit bib_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Db, Grids, DBGrids,StdCtrls, Mask, DBCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Ausleihe1: TMenuItem;
    Bcher1: TMenuItem;
    Benutzer1: TMenuItem;
    AusleiheNachNr: TMenuItem;
    BuechernachNummer: TMenuItem;
    BuechernachTitel: TMenuItem;
    BenutzernachNummer: TMenuItem;
    BenuzternachName: TMenuItem;
    BenutzerGrid: TDBGrid;
    BenutzernachKlasse: TMenuItem;
    AusleiheGrid: TDBGrid;
    BuecherGRid: TDBGrid;
    DBNavigator1: TDBNavigator;
    AusleiheNachTitelNr: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DBLookupComboBox1: TDBLookupComboBox;
    DBLookupComboBox2: TDBLookupComboBox;
    SQLGRid: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure BuechernachNummerClick(Sender: TObject);
    procedure BenutzernachNummerClick(Sender: TObject);
    procedure AusleiheNachNrClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure AusleiheNachTitelNrClick(Sender: TObject);
    procedure BuechernachTitelClick(Sender: TObject);
    procedure BenuzternachNameClick(Sender: TObject);
    procedure BenutzernachKlasseClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

uses bibdata_u;

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
with AusleiheGrid do begin
width:= 500;height := 400; top := 10; left := 20;
end;
with BuecherGrid do begin
width:= 500;height := 400; top := 10; left := 20;
end;
with BenutzerGrid do begin
width:= 500;height := 400; top := 10; left := 20;
end;
with SQLGrid do begin
width:= 500;height := 400; top := 10; left := 20;
end;

AusleiheGrid.Visible := false;
BuecherGrid.Visible := false;
BenutzerGrid.Visible := false;
SQLGrid.Visible := false;
end;


procedure TForm1.AusleiheNachNrClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsAusleihe;
bibdata.ausleihe.IndexName:='titelnr_idx';
BenutzerGrid.Visible := false;
BuecherGrid.Visible := false;
SQLGrid.Visible := false;
AusleiheGrid.Visible := true;
end;


procedure TForm1.AusleiheNachTitelNrClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsAusleihe;
bibdata.ausleihe.IndexName:='nr_idx';
BenutzerGrid.Visible := false;
BuecherGrid.Visible := false;
SQLGrid.Visible := false;
AusleiheGrid.Visible := true;

end;


procedure TForm1.BuechernachNummerClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsbuecher;
bibdata.buecher.IndexName:='titelnr_idx';
AusleiheGrid.Visible := false;
BenutzerGrid.Visible := false;
SQLGrid.Visible := false;
BuecherGrid.Visible := true;
end;


procedure TForm1.BuechernachTitelClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsbuecher;
bibdata.buecher.IndexName:='kurztitel_idx';
AusleiheGrid.Visible := false;
BenutzerGrid.Visible := false;
SQLGrid.Visible := false;
BuecherGrid.Visible := true;
end;


procedure TForm1.BenutzernachNummerClick(Sender: TObject);
begin

dbnavigator1.DataSource := bibdata.dsbenutzer;
with bibdata.benutzer do begin
  filtered := false;
  IndexName:='nr_idx';
end;
BuecherGrid.Visible := false;
AusleiheGrid.Visible := false;
SQLGrid.Visible := false;
BenutzerGrid.Visible := true;
end;

procedure TForm1.BenuzternachNameClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsbenutzer;
with bibdata.benutzer do begin
  filtered := false;
  IndexName:='name_idx';
end;
BuecherGrid.Visible := false;
AusleiheGrid.Visible := false;
SQLGrid.Visible := false;
BenutzerGrid.Visible := true;
end;

procedure TForm1.BenutzernachKlasseClick(Sender: TObject);
begin
dbnavigator1.DataSource := bibdata.dsbenutzer;
with bibdata.benutzer do begin
  filtered := false;
  IndexName:='merkmal_idx';
end;  
BuecherGrid.Visible := false;
AusleiheGrid.Visible := false;
SQLGrid.Visible := false;
BenutzerGrid.Visible := true;
end;


procedure TForm1.Button1Click(Sender: TObject);
//Alle Bcher mit der Titelnr 01XXX (Fach Biologie)
var filterstring : string;
begin
filterstring := 'titelnr=''01*''';
BuecherGrid.Visible := true;
AusleiheGrid.Visible := false;
BenutzerGrid.Visible := false;
with bibdata.buecher do begin
  IndexName := 'titelnr_idx';
  Filter:= filterstring;
  Filtered:= true;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var filterstring : string;
begin
//Alle Benutzer der Klasse  "050A"
filterstring := 'merkmal=''050A''';
BuecherGrid.Visible := false;
AusleiheGrid.Visible := false;
BenutzerGrid.Visible := true;
with bibdata.benutzer do begin
  IndexName := 'merkmal_idx';
  Filter:= filterstring;
  Filtered:= true;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
//alle Titel der ausgeliehenen Bcher des Benutzers "102212"
SQLGrid.Visible:= False;
with bibdata.SQLQuery do begin
  Close;
  SQL.Clear;
  SQL.Add('SELECT a.nr, b.kurztitel');
  SQL.Add('FROM ausleihe a, buecher b ');
  SQL.Add('WHERE a.nr=''102212'' AND a.titelnr=b.titelnr');
  try
    Open
  finally
  end
end;
  SQLGrid.Visible:= True;
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
// alle Titelnummern und Kurztitel
// die in der Klasse 050A ausgeliehen sind
SQLGrid.Visible:= False;
with bibdata.SQLQuery do begin
  Close;
  SQL.Clear;
  SQL.Add('SELECT b.name,b.merkmal, a.titelnr,c.kurztitel') ;
  SQL.Add('FROM  ausleihe a, benutzer b, buecher c');
  SQL.Add('WHERE b.nr=a.nr and b.merkmal=''ABGR'' and c.titelnr=a.titelnr');
  SQL.Add('ORDER BY b.merkmal ');
  try
    Open
  finally
  end
end;
  SQLGrid.Visible:= True;

end;





end.
